#---------------------------------------------------------------------#
# $Id: Makefile.in,v 1.5 2003-08-12 10:47:25 schuppan Exp $ #
#---------------------------------------------------------------------#

CC=@CC@
CFLAGS=@CFLAGS@ @INCS@
MAKE=@MAKE@

#---------------------------------------------------------------------#

BIN=../../bin/jnukevm
LIB=../../lib/libappjnukevm.a
OBJDIR=../../obj/app/jnukevm
OBJ=$(OBJDIR)/jnukevm.o \
$(OBJDIR)/white.o $(OBJDIR)/testing.o
LIBDIR=../../lib

all: $(BIN)

DEP=../../lib/libjnukecnt.a \
../../lib/libjnukejava.a \
../../lib/libjnukesys.a \
../../lib/libjnukepp.a \
../../lib/libjnuketest.a \
../../lib/libjnukevm.a \
../../lib/libjnukejar.a

$(BIN): $(LIB) 
	$(CC) $(CFLAGS) -I . -I ../../ -I../../sys jnukevmmain.c \
	-L. -L$(LIBDIR) -lappjnukevm -ljnukevm -ljnukejava \
	-ljnukejar -ljnuketest -ljnukecnt -ljnukepp -ljnukesys -ljnukecnt \
	-lm @ZLIB@ \
	-o $(BIN)

$(LIB): $(OBJ)
	ar rc $@ $(OBJ)
	ranlib $@

coverage:
	for f in *.c; do \
          gcov $$f | grep 'in file ' | ../../util/gcov-filter.sh ;\
        done | \
        grep -v 100.00 | \
        awk '/executed/{printf "%-20s %7s\n", $$9, $$1;}' | \
        sort -k 2 -n

clean:
	rm -f $(BIN) 
	rm -f $(LIB)
	rm -f $(OBJ)
	rm -f *.[ch]~

distclean: clean
	rm -f *.bb *.bbg *.a *.c.gcov *.da gmon.out Makefile 
	rm -f core tags cscope.out ccmalloc.log;

.PHONY: all clean distclean

#---------------------------------------------------------------------#

../../lib/libjnukecnt.a:
	$(MAKE) -C ../..

#---------------------------------------------------------------------#

INC=-I. -I../../ -I../../sys -I../../cnt -I../../java -I../../test \
	-I../../vm -I../../algo

$(OBJDIR)/jnukevm.o: jnukevm.c jnukevm.h usage.h license.h \
	$(DEP) ../../config.h ../../sys/sys.h ../../cnt/cnt.h \
	../../java/java.h ../../test/test.h ../../java/xbytecode.h \
	../../java/rbytecode.h ../../vm/vm.h
	$(CC) $(CFLAGS) $(INC) -c -o $@ jnukevm.c

$(OBJDIR)/white.o: white.c \
	$(DEP) ../../config.h ../../sys/sys.h ../../cnt/cnt.h \
	../../test/test.h
	$(CC) $(CFLAGS) $(INC) -c -o $@ white.c

$(OBJDIR)/testing.o: testing.c \
	$(DEP) ../../config.h ../../sys/sys.h ../../cnt/cnt.h \
	../../test/test.h
	$(CC) $(CFLAGS) $(INC) -c -o $@ testing.c
